<?php
/* 
    This file is part of the Auction Manager for osCommerce
    Copyright 2003, AuctionBlox.com
	
	This contribution has been released under the GNU General Public License.
	
	If you find this contribution useful, please send us an email to
	oscommerce@auctionblox.com.  If you would like to make a financial
	contribution to support further development of this contribution, 
	please visit:  http://www.auctionblox.com/oscommerce
*/
  require('includes/application_top.php');

  require(DIR_WS_FUNCTIONS . 'formatter.php');  

  require(DIR_WS_CLASSES . 'currencies.php');
  $currencies = new currencies();
  
  require(DIR_WS_CLASSES . 'auction_helper.php');  
  $auctionHelper = new auctionHelper;
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF">

<?php 

	$itemNum = $HTTP_GET_VARS['oID'];
	$item = $auctionHelper->getAuctionListing($itemNum);
	$extID = $item['extID'];

	if($HTTP_GET_VARS['action'] === 'process')
	{
		$state = $HTTP_POST_VARS['nextWorkflowState'];
		tep_db_query("update " . TABLE_AUCTION_BASKET . " set workflow_state = '$state' where auction_basket_id = $itemNum");
		
		$messageStack->add(TEXT_SUCCESS, 'success');
	}
	
	if($item['workflowStateID'] === 'FEE_CREDIT')
	{
		// This will request the fee credit
		// http://feedback.ebay.com/ws/eBayISAPI.dll?ViewDisputeConsole
	
		echo '<form action="' . FINAL_VALUE_CREDIT_URL . '" method="POST" target="_blank">';
		$nextWorkflowState = $auctionHelper->getNextWorkflowState('FEE_CREDIT');
		
		$text = TEXT_REQUEST_FVF_CREDIT;
		
	} 
	else
	{
		// This is the URL for dispute initiation (e.g. NBP Alert)
		echo '<form action="' . NPB_ALERT_URL . '" method="POST" name="ItemNumberForm" target="_blank">';
		echo "<input type='hidden' name='ItemNumber' value='$extID'";
		echo "<input type='hidden' name='MfcISAPICommand' value='CreateDispute'>";
		echo '<input type="hidden" name="CurrentPage" value="ODRDisputeInitiateItem">';
		echo '<input type="hidden" name="json" value="0">';
		echo '<input type="hidden" name="PageNumber" value="1">';
		
		$nextWorkflowState = $auctionHelper->getNextWorkflowState('NPB');
		
		$text = TEXT_REPORT_UNPAID_ITEM;
	}

?>
<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
   <tr>
    <td><?php echo $messageStack->output('feedback'); ?></td>
   </tr>
   <tr>
    <td width="100%" valign="top" class="main">
	<b>Instructions:</b><br><br>If clicking "<?php echo $text ?>" displays the eBay login page, please log in to your eBay account.<br><br>
	</td>
  </tr>
  <tr>
    <td width="100%" valign="top" align="center">
	<input type="submit" value="<?php echo $text ?> >">
	</td>
  </tr>
</table>  
</form>

<form action=" <?php echo tep_href_link(FILENAME_AUCTION_DISPUTE, tep_get_all_get_params() . 'action=process') ?>" method="POST">
<table border="0" width="100%" cellspacing="2" cellpadding="2">
  <tr>
    <td width="100%" valign="top" class="main">
	<br><br><br><br>After <b>successfully</b> performing the dispute above at eBay, click the "Change Status" button to change the status to the next state.<br><br>
	</td>
  </tr>
    <td width="100%" valign="top" align="center">
	<input type="hidden" name="nextWorkflowState" value="<?php echo $nextWorkflowState ?>">
	<input type="submit" value="Change Status">
	</td>
</table>

</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); ?>
